Unit VESA_SUP;
{ প SVGA 䨪. ⠥  ० 640*480*32K,
 ࠧ  - 65K.  CurMode  CurVESA ᮤঠ
 ଠ   ० ᫥ 맮 FindVESA.             }

interface
{$G+}
{$L VESA_SUP.OBJ}
{$F+}

uses DOS, Graph;

type
allarr=array [0..255] of integer;

VESAInfo = record                       {࠭ ଠ }
       Sign:array [0..3] of byte;       {SVGA ࠩ}
       Version:integer;
       OEM: longint;
       Capabilites:longint;
       ModeList: longint;
       TotalMemory: integer;
       Reserved: array [0..235] of byte;
           end;

VESAModeInfo = record                    {࠭ ଠ }
       ModeAttributes:  integer;         {⥪饬 ०}
       WinAAttributes:  byte;
       WinBAttributes:  byte;
       WinGranularity:  integer;
       WinSize:         integer;
       WinASegment:     word;
       WinBSegment:     word;
       WinFuncPtr:      longint;
       BytesPerScanLine:integer;
       XResolution:     integer;
       YResolution:     integer;
       XCharSize:       byte;
       YCharSize:       byte;
       NumberOfPlanes:  byte;
       BitsPerPixel:    byte;
       NumberOfBanks:   byte;
       MemoryModel:     byte;
       BankSize:        byte;
       NumberOfPages:   byte;
       Reserved:        byte;
       RedMaskSize:     byte;
       RedFieldPosition:byte;
       GreenMaskSize:   byte;
       GreenFieldPosition:byte;
       BlueMaskSize:    byte;
       BlueFieldPosition:byte;
       RsvdMaskSize:    byte;
       RsvdFieldPosition:byte;
       DirectColorModeInfo:byte;
       Reserved2:        array [0..215] of byte;
      end;

var
 CurVESA:VESAInfo;              { ᭮ }
 CurMode:VESAModeInfo;

 CV:array[0..1] of word;        {㪠⥫  }
 CM:array[0..1] of word;
 CurBank:integer;


CurRGBColor:integer;            {६  ࠭ ⥪饣 梥}
ActivePage:integer;             { ⨢ ࠭}
VisualPage:integer;             {  ࠭}
oldy:integer;                   {࣠ 뢮 窨 १}
oldaddr: longint;               {।騩   । न}
                                {ᨫ쭮 ᪮ ࠡ}


leftx     :^allarr;             {㦥 ᨢ, 㦭 }
rightx    :^allarr;             {楤 paint3A, paint3AGuro}

RleftCol  :^allarr;
GleftCol  :^allarr;
BleftCol  :^allarr;

RrightCol :^allarr;
GrightCol :^allarr;
BrightCol :^allarr;

RCol      :^allarr;
GCol      :^allarr;
BCol      :^allarr;
RGBCol    :allarr;

procedure SetColor (red,green,blue:integer);
{⠭ ⥪騩 梥}

function RGBColor (red,green,blue:integer):integer;
{頥 ᫮, ᮮ⢥饥   ᭮, 
  ᨭ.}

function GetRInt(Col:integer):integer;
{  ।  }

function GetGInt(Col:integer):integer;
{  ।  }

function GetBInt(Col:integer):integer;
{  । ᨭ }

function FindVESA:integer;
{⠭ ० SVGA}

function GetVESAMode:integer;
{頥 ⥪騩 ० SVGA
(⢨   ஢७  )}

procedure SetVESABank (start:integer);
{⠭ , ᯮ  뢮 窨  }

procedure SetActivePage(Number:integer);
{⠭ ⨢ ࠭}

procedure SetVisualPage(Number:integer);
{⠭  ࠭}

procedure WritePixel (x,y:integer);
{⥪騬 梥⮬ 뢮 ᥫ}

procedure clrscreen;
{  ࠭ ⥪騬 梥⮬}

procedure Line(x1,y1,x2,y2:integer);
{뢮  ⥪饣 梥}

procedure polyar(x1,y1,x2,y2,arpos:integer; adr: pointer);
{ १堬  ᨢ adr, 稭  arpos 
 (y2-y1) ⮢ ࠢ୮ ।  x1  x2 -
 祭.}

procedure fastLine(y,x1,x2:integer);
{ ᮢ ਧ⠫쭮 }

procedure fastpaint(x1,y1,x2,y2:integer);
{ ᪠ אַ㣮쭮  ࠭}

procedure paint3A (x1,y1,x2,y2,x3,y3:integer);
{᪠ 㣮쭨}

procedure colline (leftx,rightx,t:integer);
{㦥 楤 }

procedure fastLineGuro(y,x1,x2:integer);
{ ᮢ ਧ⠫쭮   ६ 梥⮬}

procedure paint3AGuro (x1,y1,col1,x2,y2,col2,x3,y3,col3:integer);
{᪠ 㣮쭨 ⮤ }

procedure LeaveVESA;
{⨥ SVGA ०}

implementation
{G+}

procedure SetColor;
       begin
        asm
         mov ax, red
         shr ax, 3
         shl ax, 10
         mov bx, green
         and bx, 000000011111000b
         shl bx, 2
         or  ax, bx
         mov bx, blue
         and bx, 000000011111000b
         shr bx, 3
         or  ax, bx
         mov CurRGBColor, ax
        end;
       end;

function RGBColor;
       var
       t:integer;
       begin
        asm
         mov ax, red
         shr ax, 3
         shl ax, 10
         mov bx, green
         and bx, 000000011111000b
         shl bx, 2
         or  ax, bx
         mov bx, blue
         and bx, 000000011111000b
         shr bx, 3
         or  ax, bx
         mov t, ax
        end;
       RGBColor:=t;
       end;


function GetRInt;
   var
   t:integer;
   begin
    asm
     mov ax, Col
     and ax, 7C00h
     shr ax, 7
     mov t, ax
    end;
   GetRInt:=t;
  end;


function GetGInt;
   var
   t:integer;
   begin
    asm
     mov ax, Col
     and ax, 03E0h
     shr ax, 2
     mov t, ax
    end;
   GetGInt:=t;
  end;

function GetBInt;
   var
   t:integer;
   begin
    asm
     mov ax, Col
     and ax, 01Fh
     shl ax, 3
     mov t, ax
    end;
   GetBInt:=t;
  end;


function FindVESA;
  var
   t:integer;
  begin
  asm
   push es
   push di
   les 	di, dword ptr CV
   mov 	ax, 4F00h
   int	10h
   cmp  ax, 04Fh
   jne  @001
   les 	di, dword ptr CM
   mov 	ax, 4F01h
   mov 	cx, 110h
   int 	10h
   cmp  ax, 04Fh
   jne  @001
   mov 	ax, 4F02h
   mov 	bx, 110h
   int 	10h
   cmp  ax, 04Fh
   je   @001
   jmp  @002
@001:
   mov  ax, 1
   jmp  @003
@002:
   mov  ax, 0
@003:
   mov t, ax
   pop  di
   pop  es
   end;
  FindVESA:=t;
 end;

function GetVESAMode;
   begin
     asm
	  mov 	ax, 4F03h
	  int 	10h
          cmp   ax, 04Fh
          jne @004
          mov ax, bx
          jmp @005
@004:     xor ax, ax
@005:
     end;
   end;

procedure SetVESABank;
   begin
    CurBank := start;
    asm
	 mov dx, start
	 xor bx, bx
	 call   dword ptr [CurMode+0Ch]
    end;
   end;

procedure SetActivePage;
 begin ActivePage:=Number end;

procedure SetVisualPage;
     var
      p:integer;
     begin
      if (VisualPage=Number) then exit;
      VisualPage:=Number;
      if (Number=1) then p:=480 else p:=0;
      asm
	   xor 	cx, cx
	   xor 	bx, bx
	   mov 	dx, p
	   mov 	ax, 4F07h
	   int 10h
      end;
    end;

procedure WritePixel;
   var
   addr:longint;
   start:integer;
   a:longint;
   begin
     addr:=0;
     a:=1280;
     case (y-oldy) of
      1: begin oldaddr:=oldaddr+a;addr:=oldaddr end;
     -1: begin oldaddr:=oldaddr-a;addr:=oldaddr end;
      0: addr:=oldaddr;
      else begin oldaddr:=y*a; addr:=oldaddr end;
     end;
     oldy:=y;
     asm
      shl x,1
     end;
     addr:=addr+x;
      if (ActivePage=1) then addr:=addr+614400;
     asm
      mov bx, word ptr [addr+2]
      mov start, bx
     end;
     if(start<>CurBank) then SetVESABank(start);
     asm
      mov ax, 0A000h
      mov es, ax
      mov di, word ptr addr
      mov ax, CurRGBColor
      mov ES:[di], ax
     end;
  end;


procedure clrscreen;
   external;

procedure Line;
   var
   ddx,dy,sx,sy,d1,d2,d,i,y,x:integer;

   begin
     if (x2>x1) then begin ddx:=x2-x1; sx:=1  end
                else begin ddx:=x1-x2; sx:=-1 end;
     if (y2>y1) then begin dy:=y2-y1; sy:=1  end
                else begin dy:=y1-y2; sy:=-1 end;
     if(dy<=ddx) then
      begin
       asm
        mov ax, dy
        shl ax, 1
        sub ax, ddx
        mov d, ax
        mov ax, dy
        shl ax, 1
        mov d1, ax
        mov ax, dy
        sub ax, ddx
        shl ax, 1
        mov d2, ax
       end;
       WritePixel(x1,y1);
       x:=x1+sx; y:=y1;
       for i:=1 to ddx do
        begin
         if (d>0) then begin d:=d+d2; y:=y+sy end else d:=d+d1;
	 WritePixel(x,y);
         x:=x+sx;
        end
       end
      else
       begin
       asm
        mov ax, ddx
        shl ax, 1
        sub ax, dy
        mov d, ax
        mov ax, ddx
        shl ax, 1
        mov d1, ax
        mov ax, ddx
        sub ax, dy
        shl ax, 1
        mov d2, ax
       end;
       WritePixel(x1,y1);
       x:=x1;
       y:=y1+sy;

       for i:=1 to dy do
         begin
         if(d>0) then begin d:=d+d2; x:=x+sx end else d:=d+d1;
	  WritePixel(x,y);
          y:=y+sy;
         end;
     end
  end;


procedure polyar;
     external;

procedure fastLine;
     external;

procedure fastpaint;
     var
      y:integer;
     begin
     for y:=y1 to y2 do fastLine(y,x1,x2);
     end;

procedure paint3A;
  label
   proris1;

  var
  t,y:integer;
  leftx1,rightx1: pointer;

  begin
   leftx1:=leftx;
   rightx1:=rightx;

   if (y1>y2) then
	  asm
	     mov ax, y1
	     xchg ax, y2
	     mov y1, ax

	     mov ax, x1
	     xchg ax, x2
	     mov x1, ax
	  end;

   if (y1>y3) then
	  asm
	     mov ax, y1
	     xchg ax, y3
	     mov y1, ax

	     mov ax, x1
	     xchg ax, x3
	     mov x1, ax
          end;

   if (y2>y3) then
	  asm
	     mov ax, y2
	     xchg ax, y3
	     mov y2, ax

	     mov ax, x2
	     xchg ax, x3
	     mov x2, ax
	 end;

   if ((y1=y2) and (x1>x2)) then begin t:=x1; x1:=x2; x2:=t end;

    if (y1=y2) then begin
	     polyar(x1, y1, x3, y3,0,leftx1);
	     polyar(x2, y2, x3, y3,0,rightx1);
	     goto proris1;
	        end;
    if (y2<y3) then
            begin
                polyar(x1,y1,x2,y2,0,leftx1);
		polyar(x2,y2,x3,y3,y2-y1,leftx1);
		polyar(x1,y1,x3,y3,0,rightx1)
	    end
	       else
            begin
	       polyar(x1,y1,x3,y3,0,leftx1);
	       polyar(x3,y3,x2,y2,y3-y1,leftx1);
	       polyar(x1,y1,x2,y2,0,rightx1);
            end;
proris1:       for y:=y1 to y3 do fastLine(y,rightx^[y-y1],leftx^[y-y1]);

  end;

procedure colline;
      begin
       if (leftx>rightx) then
        begin
        polyar(RrightCol^[t],rightx,RleftCol^[t],leftx,0,RCol);
        polyar(GrightCol^[t],rightx,GleftCol^[t],leftx,0,GCol);
        polyar(BrightCol^[t],rightx,BleftCol^[t],leftx,0,BCol);
        end
       else
        begin
        polyar(RleftCol^[t],leftx,RrightCol^[t],rightx,0,RCol);
        polyar(GleftCol^[t],leftx,GrightCol^[t],rightx,0,GCol);
        polyar(BleftCol^[t],leftx,BrightCol^[t],rightx,0,BCol);
        end;
      end;

procedure MergeCol(ddx:integer);
      var
      ot:integer;
      begin
      ot:=0;
      while (ot<=ddx) do
         begin
          RGBCol[ot]:=RGBColor(RCol^[ot],GCol^[ot],BCol^[ot]);
          ot:=ot+1
         end;
      end;

procedure fastLineGuro;
     external;


procedure paint3AGuro;
   label
    proris1;
   var
   y:integer;
   RC1,GC1,BC1,RC2,GC2,BC2,RC3,GC3,BC3:word;
{   leftx1,rightx1,RleftCol1,GleftCol1,BleftCol1,
   RrightCol1,GrightCol1,BrightCol1:pointer;}

   begin
   if (y1>y2) then
               asm
		   mov ax, y1
		   xchg ax, y2
		   mov y1, ax

		   mov ax, x1
		   xchg ax, x2
		   mov x1, ax

		   mov ax, col1
		   xchg ax, col2
		   mov col1, ax
	       end;

   if (y1>y3) then
               asm
		   mov ax, y1
		   xchg ax, y3
		   mov y1, ax

		   mov ax, x1
		   xchg ax, x3
		   mov x1, ax

		   mov ax, col1
		   xchg ax, col3
		   mov col1, ax
	       end;

   if (y2>y3) then
               asm
		   mov ax, y2
		   xchg ax, y3
		   mov y2, ax

		   mov ax, x2
		   xchg ax, x3
		   mov x2, ax

		   mov ax, col2
		   xchg ax, col3
		   mov col2, ax
	       end;

    if ((y1=y2) and (x1>x2)) then
	      asm
		   mov ax, x1
		   xchg ax, x2
		   mov x1, ax

		   mov ax, col1
		   xchg ax, col2
		   mov col1, ax
	      end;

   RC1:=GetRInt(col1); GC1:=GetGInt(col1); BC1:=GetBInt(col1);
   RC2:=GetRInt(col2); GC2:=GetGInt(col2); BC2:=GetBInt(col2);
   RC3:=GetRInt(col3); GC3:=GetGInt(col3); BC3:=GetBInt(col3);
   CurRGBColor:=col1;

    WritePixel(x1,y1);
    if (y1=y2) then
             begin
	     polyar(x1, y1, x3, y3,0,leftx);
	     polyar(x2, y2, x3, y3,0,rightx);
	     polyar(RC1,y1,RC3,y3,0,RleftCol);
	     polyar(GC1,y1,GC3,y3,0,GleftCol);
	     polyar(BC1,y1,BC3,y3,0,BleftCol);

	     polyar(RC2,y2,RC3,y3,0,RrightCol);
	     polyar(GC2,y2,GC3,y3,0,GrightCol);
	     polyar(BC2,y2,BC3,y3,0,BrightCol);
	     goto proris1;
	     end;

		polyar(x1,y1,x2,y2,0,leftx);
		polyar(RC1,y1,RC2,y2,0,RleftCol);
		polyar(GC1,y1,GC2,y2,0,GleftCol);
		polyar(BC1,y1,BC2,y2,0,BleftCol);

		polyar(x2,y2,x3,y3,y2-y1,leftx);
		polyar(RC2,y2,RC3,y3,y2-y1,RleftCol);
		polyar(GC2,y2,GC3,y3,y2-y1,GleftCol);
		polyar(BC2,y2,BC3,y3,y2-y1,BleftCol);

		polyar(x1,y1,x3,y3,0,rightx);
		polyar(RC1,y1,RC3,y3,0,RrightCol);
		polyar(GC1,y1,GC3,y3,0,GrightCol);
		polyar(BC1,y1,BC3,y3,0,BrightCol);

proris1:       for y:=y1 to y3 do begin
                                  colline(leftx^[y-y1],rightx^[y-y1],y-y1);
                                  MergeCol(abs(leftx^[y-y1]-rightx^[y-y1]));
				  fastLineGuro(y,rightx^[y-y1],leftx^[y-y1])
                                 end;

end;


procedure LeaveVESA;
 begin
 dispose(leftx);
 dispose(rightx);
 dispose(RleftCol);
 dispose(GleftCol);
 dispose(BleftCol);
 dispose(RrightCol);
 dispose(GrightCol);
 dispose(BrightCol);
 dispose(RCol);
 dispose(GCol);
 dispose(BCol);
  asm
   mov ax, 3
   int 10h
  end;
 end;


begin
 new(leftx);
 new(rightx);

 new(RleftCol);
 new(GleftCol);
 new(BleftCol);

 new(RrightCol);
 new(GrightCol);
 new(BrightCol);

 new(RCol);
 new(GCol);
 new(BCol);

 CV[0]:=ofs(CurVESA);
 CV[1]:=seg(CurVESA);
 CM[0]:=ofs(CurMODE);
 CM[1]:=seg(CurMODE);
end.
